%module domain

// -*- C++ -*-
%{
  #include "domain/boundary.h"
  #include "domain/domainConfiguration.h"
%}

/* domain boundary */
%ignore hysop::domain::operator<<;
%include "domain/boundary.h"


/* domain configuration */
%ignore hysop::domain::operator<<;
%ignore hysop::domain::DomainConfiguration::operator[];
%include "domain/domainConfiguration.h"

%define INSTANTIATE_DOMAIN_CONFIG_IMPL(CLASS_NAME,CLASS_TEMPLATE) 
    %template(CLASS_NAME) CLASS_TEMPLATE; 
    %extend CLASS_TEMPLATE {
        CLASS_TEMPLATE::BoundaryPair __get_item__(unsigned int k) const {
            return $self->operator[](k);
        }
        const char* __str__() const {
            std::stringstream ss;
            ss << *($self);
            return ss.str().c_str(); 
        }
    }
%enddef

%define INSTANTIATE_DOMAIN_CONFIG(INT) 
    INSTANTIATE_DOMAIN_CONFIG_IMPL(DomainConfiguration ## INT ## D, hysop::domain::DomainConfiguration<INT>)
%enddef

%formacro(INSTANTIATE_DOMAIN_CONFIG, INSTANTIATED_DIMENSIONS)

