
%module utils

// -*- C++ -*-
%{
  #include "utils/types.h"
  #include "utils/constants.h"
%}

/* types */
%warnfilter(342) hysop::multi_array;
%warnfilter(342) hysop::multi_array_view;
%warnfilter(342) hysop::const_multi_array_view;
%warnfilter(342) hysop::multi_array_ref;
%warnfilter(342) hysop::const_multi_array_ref;
%ignore hysop::multi_array;
%ignore hysop::multi_array_view;
%ignore hysop::const_multi_array_view;
%ignore hysop::multi_array_ref;
%ignore hysop::const_multi_array_ref;
%include "utils/types.h"

%define INSTANTIATE_SHAPE(INT)  %template(Shape  ## INT ## D) hysop::Shape<INT>;   %enddef
%define INSTANTIATE_OFFSET(INT) %template(Offset ## INT ## D) hysop::Offset<INT>;  %enddef
%formacro(INSTANTIATE_SHAPE,  INSTANTIATED_DIMENSIONS)
%formacro(INSTANTIATE_OFFSET, INSTANTIATED_DIMENSIONS)

/* constants */
%include "utils/constants.h"
